blob: a70b05eba41c27ae0ac0b5f5f2b318b45ad7c564 [file] [log] [blame]
garciadeblas93c61312016-09-28 15:12:48 +02001#!/bin/bash
garciadeblas38d91ee2019-11-07 16:31:23 +01002#
3# Licensed under the Apache License, Version 2.0 (the "License");
4# you may not use this file except in compliance with the License.
5# You may obtain a copy of the License at
6#
7# http://www.apache.org/licenses/LICENSE-2.0
8#
9# Unless required by applicable law or agreed to in writing, software
10# distributed under the License is distributed on an "AS IS" BASIS,
11# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12# See the License for the specific language governing permissions and
13# limitations under the License.
14#
garciadeblasd8bc5c32018-05-09 17:37:56 +020015REPOSITORY_BASE=https://osm-download.etsi.org/repository/osm/debian
garciadeblas212165a2025-11-25 15:10:44 +010016RELEASE=ReleaseEIGHTEEN
garciadeblas7bcadc52020-02-02 22:40:15 +010017REPOSITORY=stable
garciadeblas931a5122023-10-03 17:52:02 +020018DOCKER_TAG="testing-daily"
garciadeblas2bf767a2021-05-19 10:54:46 +020019DEVOPS_PATH=/usr/share/osm-devops
garciadeblas93c61312016-09-28 15:12:48 +020020
garciadeblas38d91ee2019-11-07 16:31:23 +010021function usage(){
garciadeblas212165a2025-11-25 15:10:44 +010022 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas38d91ee2019-11-07 16:31:23 +010023 echo -e "usage: $0 [OPTIONS]"
garciadeblas81077ae2023-07-03 19:31:15 +020024 echo -e "Install OSM"
garciadeblas38d91ee2019-11-07 16:31:23 +010025 echo -e " OPTIONS"
garciadeblas7f1e1042020-11-30 14:07:03 +000026 echo -e " -h / --help: print this help"
27 echo -e " -y: do not prompt for confirmation, assumes yes"
garciadeblas38d91ee2019-11-07 16:31:23 +010028 echo -e " -r <repo>: use specified repository name for osm packages"
khelifibca83312025-06-17 16:06:23 +020029 echo -e " -R <release>: use specified release for osm binaries (deb packages, ...)"
garciadeblas38d91ee2019-11-07 16:31:23 +010030 echo -e " -u <repo base>: use specified repository url for osm packages"
31 echo -e " -k <repo key>: use specified repository public key url"
garciadeblas96155042022-06-22 16:26:22 +020032 echo -e " -a <apt proxy url>: use this apt proxy url when downloading apt packages (air-gapped installation)"
garciadeblas8d8cd992024-05-21 16:04:14 +020033 echo -e " -c <kubernetes engine>: use a specific kubernetes engine (options: kubeadm, k3s), default is kubeadm"
34 echo -e " -t <docker tag> specify osm docker tag (default is latest)"
35 echo -e " -M <KUBECONFIG_FILE>: Kubeconfig of an existing cluster to be used as mgmt cluster instead of OSM cluster"
36 echo -e " -G <KUBECONFIG_FILE>: Kubeconfig of an existing cluster to be used as auxiliary cluster instead of OSM cluster"
garciadeblascf603f52025-06-04 11:57:28 +020037 echo -e " -O <KUBECONFIG_FILE>: Kubeconfig of an existing cluster to be used as OSM cluster instead of creating a new one from scratch"
garciadeblas8d8cd992024-05-21 16:04:14 +020038 echo -e " --no-mgmt-cluster: Do not provision a mgmt cluster for cloud-native gitops operations in OSM (NEW in Release SIXTEEN) (by default, it is installed)"
39 echo -e " --no-aux-cluster: Do not provision an auxiliary cluster for cloud-native gitops operations in OSM (NEW in Release SIXTEEN) (by default, it is installed)"
garciadeblas212165a2025-11-25 15:10:44 +010040 echo -e " -s <namespace> namespace where OSM helm chart will be deployed (default is osm)"
garciadeblas7f1e1042020-11-30 14:07:03 +000041 echo -e " -d <docker registry URL> use docker registry URL instead of dockerhub"
42 echo -e " -p <docker proxy URL> set docker proxy URL as part of docker CE configuration"
garciadeblas0b1c75c2025-11-11 23:04:39 +010043 echo -e " -m <MODULE>: module to test a specific docker image (NG-UI, NBI, LCM, RO, MON) (can be used several times)"
44 echo -e " -T <docker tag> use specific docker tag for the module specified with option -m"
garciadeblas212165a2025-11-25 15:10:44 +010045 echo -e " -U <docker user>: specify docker user to use when pulling images from a private registry"
46 echo -e " -D <devops path>: use particular devops installation path"
47 echo -e " -e <external IP>: set the external IP address of the OSM cluster (default is empty, which means autodetect)"
garciadeblas96155042022-06-22 16:26:22 +020048 echo -e " --debug: debug mode"
garciadeblas212165a2025-11-25 15:10:44 +010049 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblas38d91ee2019-11-07 16:31:23 +010050}
51
garciadeblasd8bc5c32018-05-09 17:37:56 +020052add_repo() {
53 REPO_CHECK="^$1"
54 grep "${REPO_CHECK/\[arch=amd64\]/\\[arch=amd64\\]}" /etc/apt/sources.list > /dev/null 2>&1
55 if [ $? -ne 0 ]
56 then
garciadeblasbd925e42018-06-14 14:32:12 +020057 need_packages_lw="software-properties-common apt-transport-https"
garciadeblas0bc87522021-10-20 22:16:17 +020058 echo -e "Checking required packages to add ETSI OSM debian repo: $need_packages_lw"
garciadeblasbd925e42018-06-14 14:32:12 +020059 dpkg -l $need_packages_lw &>/dev/null \
60 || ! echo -e "One or several required packages are not installed. Updating apt cache requires root privileges." \
garciadeblas5f420b12022-02-10 01:43:59 +010061 || sudo apt-get -qy update \
Mike Marchetti34124182018-10-16 08:22:30 -040062 || ! echo "failed to run apt-get update" \
garciadeblasbd925e42018-06-14 14:32:12 +020063 || exit 1
64 dpkg -l $need_packages_lw &>/dev/null \
65 || ! echo -e "Installing $need_packages_lw requires root privileges." \
66 || sudo apt-get install -y $need_packages_lw \
Mike Marchetti34124182018-10-16 08:22:30 -040067 || ! echo "failed to install $need_packages_lw" \
garciadeblasbd925e42018-06-14 14:32:12 +020068 || exit 1
garciadeblascf603f52025-06-04 11:57:28 +020069 curl -s -o OSM-ETSI-Release-key.gpg "$REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg"
garciadeblasbc97a012022-04-21 00:29:02 +020070 sudo APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE=1 apt-key add OSM-ETSI-Release-key.gpg \
71 || ! echo -e "Could not add GPG key $REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg" \
72 || exit 1
garciadeblas5f420b12022-02-10 01:43:59 +010073 sudo DEBIAN_FRONTEND=noninteractive add-apt-repository -y "$1"
garciadeblasbc97a012022-04-21 00:29:02 +020074 sudo DEBIAN_FRONTEND=noninteractive apt-get -y update
garciadeblas429b9f82018-03-20 02:09:44 +010075 return 0
garciadeblasd8bc5c32018-05-09 17:37:56 +020076 fi
77
78 return 1
garciadeblas55490d42016-10-29 14:22:03 +020079}
80
garciadeblas25e87d22020-01-31 14:27:29 +010081clean_old_repo() {
madaviae0784f2020-01-22 16:29:19 +053082dpkg -s 'osm-devops' &> /dev/null
madaviae0784f2020-01-22 16:29:19 +053083if [ $? -eq 0 ]; then
madaviae0784f2020-01-22 16:29:19 +053084 # Clean the previous repos that might exist
85 sudo sed -i "/osm-download.etsi.org/d" /etc/apt/sources.list
86fi
87}
88
garciadeblas0bc87522021-10-20 22:16:17 +020089function configure_apt_proxy() {
90 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
91 OSM_APT_PROXY=$1
92 OSM_APT_PROXY_FILE="/etc/apt/apt.conf.d/osm-apt"
93 echo "Configuring apt proxy in file ${OSM_APT_PROXY_FILE}"
94 if [ ! -f ${OSM_APT_PROXY_FILE} ]; then
95 sudo bash -c "cat <<EOF > ${OSM_APT_PROXY}
96Acquire::http { Proxy \"${OSM_APT_PROXY}\"; }
97EOF"
98 else
99 sudo sed -i "s|Proxy.*|Proxy \"${OSM_APT_PROXY}\"; }|" ${OSM_APT_PROXY_FILE}
100 fi
garciadeblas5f420b12022-02-10 01:43:59 +0100101 sudo apt-get -y update || FATAL "Configured apt proxy, but couldn't run 'apt-get update'. Check ${OSM_APT_PROXY_FILE}"
garciadeblas0bc87522021-10-20 22:16:17 +0200102 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
103}
104
garciadeblas0b1c75c2025-11-11 23:04:39 +0100105while getopts ":a:c:e:r:k:u:R:D:s:t:U:d:p:m:T:M:G:O:-: hy" o; do
garciadeblas38d91ee2019-11-07 16:31:23 +0100106 case "${o}" in
Antonio Marsico75a38c72020-12-21 17:29:42 +0100107 D)
108 DEVOPS_PATH="${OPTARG}"
109 ;;
garciadeblas38d91ee2019-11-07 16:31:23 +0100110 r)
111 REPOSITORY="${OPTARG}"
112 ;;
113 R)
114 RELEASE="${OPTARG}"
115 ;;
116 u)
117 REPOSITORY_BASE="${OPTARG}"
118 ;;
119 t)
garciadeblas25e87d22020-01-31 14:27:29 +0100120 DOCKER_TAG="${OPTARG}"
garciadeblas38d91ee2019-11-07 16:31:23 +0100121 ;;
garciadeblas72399e32019-11-22 10:09:40 +0100122 -)
123 [ "${OPTARG}" == "help" ] && usage && exit 0
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +0100124 ;;
garciadeblas25e87d22020-01-31 14:27:29 +0100125 :)
126 echo "Option -$OPTARG requires an argument" >&2
127 usage && exit 1
128 ;;
129 \?)
130 echo -e "Invalid option: '-$OPTARG'\n" >&2
131 usage && exit 1
132 ;;
133 h)
134 usage && exit 0
135 ;;
garciadeblas38d91ee2019-11-07 16:31:23 +0100136 *)
137 ;;
138 esac
139done
140
garciadeblas25e87d22020-01-31 14:27:29 +0100141clean_old_repo
garciadeblasd8bc5c32018-05-09 17:37:56 +0200142add_repo "deb [arch=amd64] $REPOSITORY_BASE/$RELEASE $REPOSITORY devops"
garciadeblas5f420b12022-02-10 01:43:59 +0100143sudo DEBIAN_FRONTEND=noninteractive apt-get -qy update
144sudo DEBIAN_FRONTEND=noninteractive apt-get -y install osm-devops
Antonio Marsico75a38c72020-12-21 17:29:42 +0100145$DEVOPS_PATH/installers/full_install_osm.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D $DEVOPS_PATH -t $DOCKER_TAG "$@"